// 登录
document.addEventListener('goToCaptainGPTPage', function(evt) {
  chrome.runtime.sendMessage({action: 'redirect_gpt'});
}, false);

// document.addEventListener('goToCaptainGPTPageLoginCode', function(event) {
//   chrome.runtime.sendMessage({action: 'login_gpt_by_code', params: event.detail.params, tip: '单独窗口'});
// }, false);

// 退出，关闭当前目标页面的 CaptainGPT抽屉
chrome.runtime.onMessage.addListener((request, sender, sendResponse) =>{
  if (request.message === "close CaptainGPT Window") {
    let closeEl = document.getElementById("close-captaingpt-drawer");
    if (closeEl) {
      closeFlag = 1;
      isLogout = 1;
      closeEl.dispatchEvent(new Event("click"));
    }
  } else if (request.message === "CaptainGPT ContextMenus Action") {
    window.postMessage({type: request.message, menuItemId: request.menuItemId, selectedText: request.selectedText}, '*');
  } else if (request.message === "login_gpt_by_code_background") {
    window.postMessage({type: "login_gpt_by_code_background_to_content", res: request.res}, '*');
  }
});
var closeFlag = 1;
var isLogout = 0;
window.onload = () => {
  // 插件基本路径
  let id = chrome.runtime.id;
  var baseUrl = "chrome-extension://" + id;
  var indexUrl = baseUrl + "/views/CaptainGPT/dist/index.html#/";

  // 全屏标识
  var fullViewFlag = 0;
  var isShowLeftContainer = 1;

  // 图片加载
  var closeImgUrl = chrome.runtime.getURL("statics/imgs/shouqi_32.png");
  var fullImgUrl = chrome.runtime.getURL("statics/imgs/quanping_32.png");
  var halfImgUrl = chrome.runtime.getURL("statics/imgs/banping_32.png");
  var loadingUrl = chrome.runtime.getURL("statics/imgs/loading.gif");
  var logoUrl = chrome.runtime.getURL("statics/imgs/logo_27b8d0.svg");
  var logo240 = chrome.runtime.getURL("statics/imgs/logo_240.png");
  var hideImgUrl = chrome.runtime.getURL("statics/imgs/hide.png");
  var showImgUrl = chrome.runtime.getURL("statics/imgs/show.png");
  // var packageImgUrl = chrome.runtime.getURL("statics/imgs/package_store.png");
  // var settingImgUrl = chrome.runtime.getURL("statics/imgs/setting.png");

  // 提示词
  var prompt = '';

  // CaptainGPT 功能按钮位置变量
  var dragButton = null;
  var isDragging = false;
  var isDragEvent = false;
  var startLeft;
  var startTop;

  // 缓存一下插件版本号，以便更新判断
  if (chrome && chrome.storage && chrome.storage.local && chrome.runtime) {
    chrome.storage.local.set({
      gptVersion: chrome.runtime.getManifest().version
    })
  }

  var drawerEl = '';

  // 打开GPT抽屉
  function openDrawer(noImmediatelySend = 0, operationType = '', params) {
    let existChormeStorage = chrome && chrome.storage && chrome.storage.local;
    if (existChormeStorage) {
      chrome.storage.local.set({
        openFromPage: 1
      })
    }
    // 使用chrome.storage.local来传递prompt参数，且打开GPT抽屉是立即发送问题
    if (prompt && existChormeStorage) {
      chrome.storage.local.set({
        initParams: {
          noContextualizing: 1,
          noImmediatelySend: noImmediatelySend,
          input: prompt,
          operationType,
          params
        }
      });
    } else {
      existChormeStorage && chrome.storage.local.set({initParams: ''});
    }

    // 判断抽屉是否处于打开状态
    if (closeFlag == 2 || closeFlag == 3) {
      closeFlag = 2;
      document.getElementById("gpt-drawer-mask") && document.getElementById("gpt-drawer-mask").classList.remove("gpt-drawer-close");
      // 更新 prompt
      let f = document.getElementById("captaingpt-iframe");
      if (prompt && f) {
        // 1、此方式每次都会刷新，交互上不太友好，使用方式2
        // f.src = '';
        // setTimeout(() => {
        //   f.src = indexUrl;
        // }, 20);
        // 2、通过postMessage 更新 prompt
        f.contentWindow.postMessage({
          type: 'open window',
          captaingpt:true,
          noImmediatelySend: noImmediatelySend,
          data: prompt,
          isOpen: true,
          operationType,
          params
        },'*');
        prompt = '';
      }
      return;
    }
    
    // 抽屉外壳
    drawerEl = document.createElement("div");
    drawerEl.setAttribute("class", "gpt-drawer-mask");
    drawerEl.setAttribute("id", "gpt-drawer-mask");
    // 从缓存中获取宽度还原
    if (existChormeStorage) {
      chrome.storage.local.get(["gptMaskWidth"], (result) => {
        if (result && result.gptMaskWidth) {
          drawerEl.style.width = result.gptMaskWidth;
          if (result.gptMaskWidth == '100%') {
            fullViewFlag = 1;
            drawerEl.classList.add("full-page-view");
          }
        }
      });
    }
    // 加载效果
    var loadingEl = document.createElement("img");
    loadingEl.setAttribute("id", "captaingpt-loading");
    loadingEl.src = loadingUrl;
    drawerEl.appendChild(loadingEl);
    // 拖拽元素
    var resizeController = document.createElement("div");
    resizeController.setAttribute("class", "gpt-resize-controller");
    resizeController.addEventListener('mousedown', startResize);
    // resizeController.addEventListener("mouseout", endResize);
    drawerEl.appendChild(resizeController);
    // 遮罩层
    let wrapEl = document.createElement("div");
    wrapEl.setAttribute("class", "gpt-drawer-warp");
    wrapEl.setAttribute("id", "gpt-drawer-warp");
    wrapEl.innerHTML = 
    `<div id="close-captaingpt-drawer" class="close-btn" title="收起">
      <div id="close-captaingpt-drawer-btn"><img src="${closeImgUrl}"></div>  
    </div>
    <div id="full-view-captaingpt" class="close-btn full-view-btn">
      <div id="full-view-captaingpt-btn" title="${fullViewFlag==1?'半屏':'全屏'}"><img src="${fullImgUrl}"></div>  
    </div>
    <div id="captaingpt-aside-show" class="close-btn captaingpt-aside-show">
      <div id="captaingpt-aside-show-btn"><img src="${hideImgUrl}"></div>  
    </div>`;
    // `<div id="captaingpt-package-store-show" class="close-btn captaingpt-package-store-show" title="套餐">
    //   <div id="captaingpt-package-store-show-btn"><img src="${packageImgUrl}"></div>  
    // </div>
    // <div id="captaingpt-setting-show" class="close-btn captaingpt-setting-show" title="设置">
    //   <div id="captaingpt-setting-show-btn"><img src="${settingImgUrl}"></div>  
    // </div>`;
    drawerEl.appendChild(wrapEl);

    // GPT
    var gptEl = document.createElement("iframe");
    gptEl.setAttribute("id", "captaingpt-iframe");
    gptEl.setAttribute("sandbox", "allow-same-origin allow-scripts allow-popups");
    gptEl.src = indexUrl;
    gptEl.width = "100%";
    gptEl.height = "100%";
    gptEl.style.border = "1px";
    // 抽屉添加GPT
    wrapEl.appendChild(gptEl);
    // 将抽屉添加到页面body中
    document.body.appendChild(drawerEl);
    closeFlag = 2;

    // iframe加载完毕关闭加载效果
    document.getElementById("captaingpt-iframe").onload = (e) => {
      if (loadingEl) {
        drawerEl.removeChild(loadingEl);
        loadingEl = '';
      }
    }

    // 关闭
    let closeEl = document.getElementById("close-captaingpt-drawer");
    closeEl.addEventListener("click", () => {
      if (isLogout==0) {
        closeFlag = 3;
      }
      drawerEl.classList.add("gpt-drawer-close");
      if (isLogout == 1) {
        closeFlag = 1;
        if (document.body.contains(drawerEl)) {
          document.body.removeChild(drawerEl)
        }
      }
    })

    // 全屏
    let fullWiewEl = document.getElementById("full-view-captaingpt");
    fullWiewEl.addEventListener("click", () => {
      let btn = document.getElementById("full-view-captaingpt-btn");
      if (fullViewFlag == 1) {
        fullViewFlag = 0;
        drawerEl.classList.remove("full-page-view");
        drawerEl.style.width = "60%";
        btn.innerHTML = `<img src="${fullImgUrl}">`;
        btn.setAttribute("title", "全屏");
      } else {
        fullViewFlag = 1;
        drawerEl.classList.add("full-page-view");
        drawerEl.style.width = "100%";
        btn.innerHTML = `<img src="${halfImgUrl}">`;
        btn.setAttribute("title", "半屏");
      }
      // 将宽度记录在缓存中
      if (existChormeStorage) {
        chrome.storage.local.set({
          gptMaskWidth: drawerEl.style.width
        });
      }
    })

    // 显示或隐藏左侧栏
    initAsideShow();
    function initAsideShow() {
      if (existChormeStorage) {
        chrome.storage.local.get(["isShowLeftContainer"], (result) => {
          if (result && result.isShowLeftContainer) {
            let btn = document.getElementById("captaingpt-aside-show-btn");
            if (result.isShowLeftContainer==1) {
              btn.innerHTML = `<img src="${hideImgUrl}">`;
              btn.setAttribute("title", "收起会话列表");
            } else {
              btn.innerHTML = `<img src="${showImgUrl}">`;
              btn.setAttribute("title", "展开会话列表");
            }
          }
        });
      }
    }
    let asideShowEl = document.getElementById("captaingpt-aside-show");
    asideShowEl.addEventListener("click", handleAsideShowBtnClick);
    function handleAsideShowBtnClick() {
      if (existChormeStorage) {
        chrome.storage.local.get(["isShowLeftContainer"], (result) => {
          if (result && result.isShowLeftContainer) {
            if (result.isShowLeftContainer == 1) {
              changeLeftContainerShow(2);
            } else {
              changeLeftContainerShow(1);
            }
          } else {
            changeLeftContainerShow(2);
          }
        });
      }
    }
    function changeLeftContainerShow(val) {
      let btn = document.getElementById("captaingpt-aside-show-btn");
      if (val==1) {
        btn.innerHTML = `<img src="${hideImgUrl}">`;
        btn.setAttribute("title", "收起会话列表");
      } else {
        btn.innerHTML = `<img src="${showImgUrl}">`;
        btn.setAttribute("title", "展开会话列表");
      }
      let f = document.getElementById("captaingpt-iframe");
      chrome.storage.local.set({
        isShowLeftContainer: val
      })
      f.contentWindow.postMessage({
        type: 'show aside list',
        isShowLeftContainer: val,
        captaingpt:true,
        noImmediatelySend: noImmediatelySend,
        data: prompt,
        isOpen: true,
      },'*');
    }

    // 打开套餐页面
    // let packageStoreEl = document.getElementById("captaingpt-package-store-show");
    // packageStoreEl.addEventListener("click", () => {
    //   let f = document.getElementById("captaingpt-iframe");
    //   f.contentWindow.postMessage({
    //     type: 'open package store',
    //     captaingpt:true,
    //     noImmediatelySend: noImmediatelySend,
    //     data: prompt,
    //     isOpen: true,
    //   },'*');
    // })

    // // 打开设置弹窗
    // let settingEl = document.getElementById("captaingpt-setting-show");
    // settingEl.addEventListener("click", () => {
    //   let f = document.getElementById("captaingpt-iframe");
    //   f.contentWindow.postMessage({
    //     type: 'open setting dialog',
    //     captaingpt:true,
    //     noImmediatelySend: noImmediatelySend,
    //     data: prompt,
    //     isOpen: true,
    //   },'*');
    // })
  }

  //****************************************************************** 拖拽外壳左侧调整宽度 start ***********************************************************************/
  var widthResizing = false;
  var startX = '';
  // 开始拖拽宽度
  function startResize(e) {
    widthResizing = true
    startX = e.clientX
    setTimeout(() => {
      if (widthResizing) {
        startX = e.clientX
      }
    }, 100)
  }
  // 实时处理拖拽宽度
  function handleResizing(e) {
    if (widthResizing) {
      // 拖动宽度
      let deltaX = startX - e.clientX
      // 新的宽度为原有宽度加上拖动宽度
      let newWidth = drawerEl.clientWidth + deltaX
      if (newWidth >= 400 && newWidth <= window.innerWidth || (newWidth==60 || newWidth==100)) {
        drawerEl.style.width = newWidth + 'px'
        startX = e.clientX
      }
    }
  }
  // 拖拽结束
  function endResize() {
    if (widthResizing) {
      widthResizing = false;
      // 将宽度记录在缓存中
      if (chrome && chrome.storage && chrome.storage.local) {
        chrome.storage.local.set({
          gptMaskWidth: drawerEl.style.width
        });
      }
    }
  }
  //****************************************************************** 拖拽外壳左侧调整宽度 end ***********************************************************************/

  /*
  * 目标页面注入 CaptainGPT 功能按钮
  * 请先在 manifest.js host_permissions配置中添加 相应网站权限
  * 按钮样式可以在 css/style.css 中添加
  */
  // 页面注入 CaptainGPT 功能按钮
  initPageBtn();
  function initPageBtn() {
    let customBtn = document.createElement("div");
    // customBtn.innerText = "CaptainGPT";
    customBtn.setAttribute("class", "CaptainGPT-Msg-Btn");
    customBtn.setAttribute("id", "CaptainGPT-Msg-Btn");
    customBtn.setAttribute("title", "CaptainGPT");
    customBtn.style.backgroundImage = `url(${logo240})`;
    customBtn.style.backgroundSize = "contain";
    setTimeout(() => {
      if (!document.body.contains(customBtn)) {
        if (chrome && chrome.storage && chrome.storage.local) {
          chrome.storage.local.get(["CaptainGPTBtnPosition"], (result) => {
            // 从缓存中获取上次放置的位置
            if (result && result.CaptainGPTBtnPosition) {
              let p = result.CaptainGPTBtnPosition;
              if (parseInt(p.left) > window.innerWidth) {
                p.left = window.innerWidth - 40;
              }
              if (parseInt(p.top) > window.innerHeight) {
                p.top = window.innerHeight - 40;
              }
              customBtn.style.left = p.left + "px";
              customBtn.style.top = p.top + "px";
            }
          });
        }
        document.body.appendChild(customBtn)
        initClickEvent();
        initDragEvent();
      }
    }, 500)
  }

  //******************************************************** CaptainGPT 入口按钮点击事件相关 start ***********************************************************************/
  function initClickEvent() {
    clickBtn = document.getElementById('CaptainGPT-Msg-Btn');
    clickBtn.addEventListener('click', clickCaptainGPTBtn);
  }
  function clickCaptainGPTBtn(e) {
    if (!isDragEvent) {
      e.preventDefault();
      prompt = '';
      // 单独打开一个窗口
      // chrome.runtime.sendMessage({ message: "open window from page", prompt }, (res) => {});
      // 以抽屉的形式打开
      openDrawer(1);
    } else {
      isDragEvent = false;
    }
  }
  //******************************************************** CaptainGPT 入口按钮点击事件相关 end ***********************************************************************/

  //******************************************************** CaptainGPT 商品页面Listing优化入口相关 start ***********************************************************************/
  var featureBullets = ''
  if(location && location.host.includes("www.amazon")) {
    initOptimizeEntrance()
  }
  function initOptimizeEntrance() {
    // 
    let btn = document.createElement("div")
    btn.setAttribute("class", "optimize-entrance-btn")
    btn.setAttribute("id", "optimize-entrance-btn-container")
    // btn.innerText = "优化FeatureBullets"
    let downImgUrl = chrome.runtime.getURL("statics/imgs/down.png");
    let rightImgUrl = chrome.runtime.getURL("statics/imgs/right.png");
    btn.innerHTML = `
      <div class="btn-text" id="optimize-entrance-btn">优化FeatureBullets<img src="${downImgUrl}" /></div>
      <div class="ext-operation" id="ext-operation-container">
        <div class="btn-text" id="inventory-mode-btn">库存模式建议<img src="${rightImgUrl}" /></div>
        <div class="btn-text" id="matching-sales-btn">搭配销售建议<img src="${rightImgUrl}" /></div>
      </div>
    `
    // 如果有元素类名为a-unordered-list a-vertical a-spacing-mini的
    featureBullets = document.getElementsByClassName("a-unordered-list a-vertical a-spacing-mini")
    if (featureBullets && featureBullets.length) {
      featureBullets[0].after(btn)
    } else {
      featureBullets = document.getElementsByClassName("a-unordered-list a-vertical a-spacing-small")
      if (featureBullets && featureBullets.length) {
        btn.classList.add("optimize-entrance-position-absolute")
        featureBullets[0].before(btn)
      }
    }
    initOptimizeEntranceEvent()
  }
  function initOptimizeEntranceEvent() {
    let optimizeBtn = document.getElementById('optimize-entrance-btn');
    optimizeBtn && optimizeBtn.addEventListener('click', clickOptimizeBtn);
    let parentCon = document.getElementById('optimize-entrance-btn-container');
    parentCon && parentCon.addEventListener('mouseover', (event) => {
      document.getElementById('ext-operation-container').style.display = 'block';
    });
    parentCon && parentCon.addEventListener('mouseout', (event) => {
      document.getElementById('ext-operation-container').style.display = 'none';
    });
    let inventoryModeBtn = document.getElementById('inventory-mode-btn');
    inventoryModeBtn && inventoryModeBtn.addEventListener('click', inventoryModeSuggess);
    let matchingSalesBtn = document.getElementById('matching-sales-btn');
    matchingSalesBtn && matchingSalesBtn.addEventListener('click', matchingSalesSuggess);
  }
  function clickOptimizeBtn(e) {
    e.preventDefault();
    let contents = ''
    if (featureBullets && featureBullets.length) {
      if (featureBullets.length == 1) {
        contents = featureBullets[0].innerText
      } else {
        for(let i = 0; i < featureBullets.length; i ++) {
          contents += featureBullets[i].innerText + "\n"
        }
      }
    }
    let title = document.getElementById("productTitle").innerText
    prompt = `我是一名亚马逊卖家，我需要你扮演一个亚马逊运营的专家，结合以下信息帮我优化Feature Bullets，请给我两种语言[当前Feature Bullets所属语言]的优化结果和[中文]的优化结果。\nProduct Title:\n${title}\nFeature Bullets:\n${contents}`;
    openDrawer(0, 'featureBullets', {title: title, contents, contents});
  }
  function inventoryModeSuggess(e) {
    e.preventDefault();
    let title = document.getElementById("productTitle").innerText
    prompt = `我是一名亚马逊卖家，我需要你扮演一个亚马逊运营的专家，根据以下商品标题：${title}，帮我分析一下这种类型的商品适合使用哪种库存模式，是FBA还是FBM？您可以考虑以下因素：商品特性（大小、重量、易碎性）、销售情况、成本结构、客户服务需求等。请给出详细的分析和建议，以便我能够做出明智的决策。`;
    openDrawer(0, 'inventoryMode', {title: title});
  }
  function matchingSalesSuggess(e) {
    e.preventDefault();
    let title = document.getElementById("productTitle").innerText
    prompt = `我是一名亚马逊卖家，我需要你扮演一个亚马逊运营的专家，根据我的商品标题：${title}，我想了解有哪些商品可以与这种类型的商品一起打包销售，或者可以作为补充商品；我还想了解如何将它们组合销售，以提高整体销售额和吸引更多顾客。希望你能帮我分析一下相关产品的搭配销售策略，以及在亚马逊等电商平台上这类组合销售策略的表现情况。`;
    openDrawer(0, 'matchingSales', {title: title});
  }
  //******************************************************** CaptainGPT 商品页面Listing优化入口相关 end ***********************************************************************/

  //******************************************************** CaptainGPT 商品页面评论分析入口相关 start ***********************************************************************/
  if(location && location.host.includes("www.amazon")) {
    initReviewsEntrance()
  }
  function initReviewsEntrance() {
    // 
    let btn = document.createElement("div")
    btn.setAttribute("class", "reviews-entrance-btn")
    btn.setAttribute("id", "reviews-entrance-btn")
    btn.innerText = "评论分析"
    let reviewsContainer = document.getElementById("cm-cr-dp-review-header")
    if (reviewsContainer) {
      reviewsContainer.after(btn)
    }
    let moreReviewsContainer = document.getElementById("cm_cr-review_list")
    if (moreReviewsContainer) {
      moreReviewsContainer.before(btn)
    }
    initReviewsEntranceEvent()
  }
  function initReviewsEntranceEvent() {
    let reviewsBtn = document.getElementById('reviews-entrance-btn');
    reviewsBtn && reviewsBtn.addEventListener('click', clickReviewsBtn);
  }
  function clickReviewsBtn(e) {
    e.preventDefault();
    // 显示确认框
    let confirmEl = document.createElement("div")
    confirmEl.setAttribute("class", "review-confirm-tip-mark")
    confirmEl.setAttribute("id", "review-confirm-tip")
    confirmEl.innerHTML = `
    <div class="review-confirm-tip">
      <div style="margin-top: 20px;">分析商品品类的卖点，市场机会，用户痛点，并根据用户评论分析该商品的购买原因，优缺点和改进措施，消耗点数为 评论数 * 0.5，是否继续？</div>
      <div style="margin-top: 30px; text-align: right;"><button id="removeReviewConfirmTip" style="margin-right: 6px">取消</button><button id="clickReviewsBtnSubmit" style="background: #27b8d0; color: #fff;">继续</button></div>
    </div>
    `
    document.body.appendChild(confirmEl);
    let closeBtn = document.getElementById('review-confirm-tip');
    closeBtn && closeBtn.addEventListener('click', removeReviewConfirmTip);
    let cancelBtn = document.getElementById('removeReviewConfirmTip');
    cancelBtn && cancelBtn.addEventListener('click', removeReviewConfirmTip);
    let submitBtn = document.getElementById('clickReviewsBtnSubmit');
    submitBtn && submitBtn.addEventListener('click', clickReviewsBtnSubmit);
  }
  function removeReviewConfirmTip() {
    let el = document.getElementById("review-confirm-tip")
    if (el) {
      document.body.removeChild(el);
    }
  }
  function clickReviewsBtnSubmit() {
    removeReviewConfirmTip();
    let contents = ''
    let el = document.getElementsByClassName("review-text")
    let cost_value = 1
    let review_num = 0
    if (el && el.length) {
      cost_value = Math.ceil(el.length / 2)
      review_num = el.length
      for(let i = 0; i < el.length; i ++)
      contents += `${i+1}.${el[i].innerText}\n`
    }
    let titleEl = document.getElementById("productTitle") || document.getElementsByClassName("a-row product-title")&&document.getElementsByClassName("a-row product-title")[0]
    let title = titleEl.innerText
    // prompt = `我是一名亚马逊卖家，我需要你扮演一个亚马逊运营的专家，结合以下信息帮我分析用户主要评论，以便我做出相应的改进和推广。\n商品标题:\n${title}\n用户评论:\n${contents}`;
    prompt = "#CaptainGPT数据分析 #review分析\n"+"请帮我分析商品"+title+"相关review数据"
    openDrawer(0, 'reviewAnalysis', {title: title, contents: contents, review_num: review_num, cost_value: cost_value});
  }
  //******************************************************** CaptainGPT 商品页面评论分析入口相关 end ***********************************************************************/

  //********************************************************* CaptainGPT 入口按钮可在页面随意拖动放置位置 start *************************************************************/
  function initDragEvent() {
    dragButton = document.getElementById('CaptainGPT-Msg-Btn');
    dragButton.addEventListener('mousedown', startDrag);
    dragButton.addEventListener('mouseup', stopDrag);
  }

  function startDrag(e) {
    isDragging = true;
    setTimeout(() => {
      if (isDragging) {
        isDragEvent = true;
        dragButton.style.cursor = "move";
        dragButton.style.transform = "scale(1.1)";
        startLeft = e.clientX - dragButton.offsetLeft;
        startTop = e.clientY - dragButton.offsetTop;
      }
    }, 400)
  }

  function drag(e) {
    if (!isDragging) return;
    let newX = e.clientX - startLeft;
    let newY = e.clientY - startTop;
    let windowWidth = window.innerWidth - dragButton.offsetWidth;
    let windowHeight = window.innerHeight - dragButton.offsetHeight;
    newX = Math.max(0, Math.min(newX, windowWidth));
    newY = Math.max(0, Math.min(newY, windowHeight));
    dragButton.style.left = newX + 'px';
    dragButton.style.top = newY + 'px';
    // 缓存当前入口按钮位置
    if (chrome && chrome.storage && chrome.storage.local) {
      chrome.storage.local.set({
        CaptainGPTBtnPosition: {
          left: newX,
          top: newY,
        }
      });
    }
  }

  function stopDrag(event) {
    isDragging = false;
    dragButton.style.cursor = "pointer";
    dragButton.style.transform = "scale(1)";
    document.removeEventListener('mousemove', drag);
    setTimeout(() => {
      isDragEvent = false;
    }, 1000)
  }
  //********************************************************* CaptainGPT 入口按钮可在页面随意拖动放置位置 end *************************************************************/


  //******************************************************** CaptainGPT 特定功能事件相关 start ***********************************************************************/
  /**
   * 目标页面 监听选中文本事件
   * 
   */
  // 功能列表popper
  // var closePopperFlag = 1;
  var positionX = 0;
  var positionY = 0;
  var gptActionListEl = document.createElement("div");
  gptActionListEl.setAttribute("id", "gpt-action-list-popper");
  gptActionListEl.innerHTML = 
  ` <div id="captaingpt-tooltip" class="captaingpt-tooltip">
      <div class="tooltip-title"><img src="${logoUrl}"><span>Captain<span style="font-weight: bold; color: #27b8d0">GPT</span></span></div>
    </div>
    <div id="gpt-action-list-container" class="gpt-action-list-container">
      <div class="popper-title"><span>CaptainGPT 跨境电商运营最好用的AI助理</span><span id="popper-close-btn">X</span></div>
      <div class="gpt-action-list-content">
        <div class="action-item" id="captaingpt_zh_translate">翻译成中文</div>
        <div class="action-item" id="captaingpt_en_translate">翻译成英文</div>
        <div class="action-item" id="captaingpt_msg_reply">生成消息答复</div>
        <div class="action-item" id="captaingpt_optimizing_reply">优化消息答复</div>
      </div>
    </div>
  `;

  // 监听页面中的文本选中事件
  document.addEventListener("mouseup", (event) => {
    if (document.getElementById("gpt-action-list-container")) {document.getElementById("gpt-action-list-container").style.display = "none";}
    if (['captaingpt_zh_translate', 'captaingpt_en_translate', 'captaingpt_msg_reply', 'captaingpt_optimizing_reply'].includes(event.target.id)) {
      return;
    }
    widthResizing ? endResize(event) : '';
    var selectedText = window.getSelection().toString();
    if (selectedText) {
      // 用户选中了文本
      // 是否开启选中显示功能按钮
      if (chrome && chrome.storage && chrome.storage.local) {
        chrome.storage.local.get(["isSelectServer"], (result) => {
          // 从缓存中获取是否开启划词辅助功能
          if (result && result.isSelectServer === "disabled") {
            return;
          }
          showActionList(event.clientX, event.clientY, selectedText);
        });
      } else {
        showActionList(event.clientX, event.clientY, selectedText);
      }
    }
  });
  function showActionList(x, y, selectedText) {
    // 创建一个弹出的DOM元素，这里使用一个简单的div元素作为示例
    gptActionListEl.style.position = 'fixed';
    positionX = x + 16;
    positionY = y + 10;
    // 超出右边显示在左边
    if (positionX + 108 > window.innerWidth) {
      positionX = x - 108;
    }
    // 超出底部显示在上面
    if (positionY + 30 > window.innerHeight) {
      positionY = y - 28;
    }
    gptActionListEl.style.top = positionY + 'px';
    gptActionListEl.style.left = positionX + 'px';
    gptActionListEl.style.zIndex = 99999;
    document.body.appendChild(gptActionListEl);
    // closePopperFlag = 0;

    // 鼠标移入移出，显示隐藏操作列表
    gptActionListEl.addEventListener("mouseover", (event) => {
      let container = document.getElementById("gpt-action-list-container");
      if (container) {
        container.style.display = "block";
        // 超出右边显示在左边
        if (positionX + container.offsetWidth > window.innerWidth) {
          container.style.right = "-1px";
          container.style.left = "auto";
        } else {
          container.style.right = "auto";
          container.style.left = "-1px";
        }
        // 超出底部显示在上面
        if (positionY + container.offsetHeight > window.innerHeight) {
          container.style.bottom = "28px";
          container.style.top = "auto";
        } else {
          container.style.top = "28px";
          container.style.bottom = "auto";
        }
      }
    })
    gptActionListEl.addEventListener("mouseout", (event) => {
      document.getElementById("gpt-action-list-container").style.display = "none";
    })

    // 给操作列表添加事件处理程序
    gptActionListEl.addEventListener('click', (event) => {
      // 根据选择的操作进行相应的处理
      executeAction(event.target.id, selectedText)
      // 清除操作列表
      if (document.body.contains(gptActionListEl)) {
        document.body.removeChild(gptActionListEl)
      }
    });
  }

  function executeAction(id, selectedText) {
    if (selectedText) {
      // 根据选择的操作进行相应的处理
      prompt = '';
      switch (id) {
        case "captaingpt_en_translate": prompt = `我是一名跨境卖家，我的目标市场是[美国]，请帮我把下面这段话翻译为[英语]，要求：使用本地化语言，让消费者看起来通俗易懂，简单清晰。注意语法表达，让内容看起来是纯正的本地人表达。请同时给我[中文]。
  [${selectedText}]`;
        break;

        case "captaingpt_zh_translate": prompt = `请帮我将以下内容翻译成中文
  [${selectedText}]`;
        break;

        case "captaingpt_msg_reply": prompt = `我是一名跨境客服，买家给我发送了消息，请帮我生成合适的回复内容。你需要注意客户的情绪，如果情感是积极的或中性的，感谢他们的评价；如果情感是消极的，道歉并建议他们联系客户服务，在回答中需要针对客户的问题答复。 希望语气温和，表达清晰，符合顾客的表达习惯，请先将买家消息翻译成中文，然后给出令人温暖的答复。请给我 [英文] 和中文版本。
  买家消息内容：[${selectedText}]`;
        break;

        case "captaingpt_optimizing_reply": prompt = `我是一名跨境客服，请帮我优化我的回复内容。参考我给出的回复内容，希望语气温和，表达清晰，给出令人温暖的答复。请给我[英文] 和中文版本。
  回复内容：[${selectedText}]`;
        break;
      }
      if (prompt) {
        openDrawer(0);
      }
    }
  }

  // 关闭popper
  // 1、页面空白处
  document.addEventListener("click", closeActionListPopper);
  function closeActionListPopper(e){
    if (document.body.contains(gptActionListEl)) {
      document.body.removeChild(gptActionListEl);
      // if (closePopperFlag == 1) {
      //   document.body.removeChild(gptActionListEl);
      // } else {
      //   closePopperFlag = 1;
      // } 
    }
  }
  // 2、popper关闭按钮
  if (document.getElementById("popper-close-btn")) {
    document.getElementById("popper-close-btn").addEventListener("click", (event) => {
      if (document.body.contains(gptActionListEl)) {
        document.body.removeChild(gptActionListEl)
      }
    })
  }
  //******************************************************** CaptainGPT 特定功能事件相关 end ***********************************************************************/

  // 监听iframe内登录页传过来的参数
  window.addEventListener('message', event => {
    if (event.data.type === "reload CaptainGPT Window" && event.data.captaingpt_login) {
      if (chrome && chrome.storage && chrome.storage.local) {
        chrome.storage.local.set({
          loginParams: ''
        });
        chrome.storage.local.set({
          loginParams: event.data.params
        });
      }
      let f = document.getElementById('captaingpt-iframe');
      if (f) {
        setTimeout(() => {
          f.src = f.src;
        }, 500)
      }
    } else if (event.data.type === "reload CaptainGPT Window Login Code" && event.data.captaingpt_login) {
      chrome.runtime.sendMessage({action: 'login_gpt_by_code', params: event.data.params, tip: '页面注入'});
    } else if (event.data.type === "update CaptainGPT Version" && event.data.captaingpt_version) {
      let timestamp = Date.parse(new Date());
      window.open(event.data.downUrl+'?v='+timestamp);
    } else if (event.data.type === "mousemove Drawer Width" && event.data.event_params) {
      handleResizing({clientX: event.data.event_params.screenX})
    } else if (event.data.type === "mouseup Drawer Width") {
      endResize()
    } else if (event.data.type === "CaptainGPT ContextMenus Action") {
      executeAction(event.data.menuItemId, event.data.selectedText)
    } else if (event.data.type === "login_gpt_by_code_background_to_content") {
      setTimeout(() => {
        let f = document.getElementById("captaingpt-iframe");
        if (f) {
          f.contentWindow.postMessage({
            type: 'show login qrcode status',
            captaingpt:true,
            data: {...event.data.res, url: indexUrl}
          },'*');
        } else {
          window.postMessage({
            type: 'show login qrcode status',
            captaingpt:true,
            data: {...event.data.res, url: indexUrl}
          },'*');
        }
      }, 2000)
    }
  });

  // 监听document 鼠标移动事件，窗口宽度拖拽和入口按钮位置拖动放置都用到了该事件监听
  document.addEventListener('mousemove', handleMousemove);
  function handleMousemove(e) {
    if (isDragging) {
      drag(e);
    } else if (widthResizing) {
      handleResizing(e);
    }
  }
  document.addEventListener('mouseup', (event) => {
    if (isDragging) {
      stopDrag();
    } else if (widthResizing) {
      endResize();
    }
  });
}