// 当脚本被执行时
window.onload = () => {
	if (chrome && chrome.storage && chrome.storage.local) {
		chrome.storage.local.set({
			openFromPage: 2
		})
		chrome.storage.local.set({initParams: ''});
	}
	// 获取当前窗口
	let currentWindow = '';
	chrome.windows && chrome.windows.getCurrent((win) => {
		currentWindow = win;
		judgeWindowExist();
	})

	// 打开CaptainGPT窗口，打开前先判断一下是否已经有打开过的了，有则聚焦，无则创建
	function judgeWindowExist() {
		if (chrome && chrome.storage && chrome.storage.local) {
			chrome.storage.local.get(["gptWindowId"], (result) => {
				// 使用缓存的窗口ID
				if (result && result.gptWindowId) {
					chrome.windows.get(result.gptWindowId, (window) => {
						if (chrome.runtime.lastError) {
								chrome.storage.local.remove(["gptWindowId"]);
								openpage();
						} else {
							chrome.windows.update(result.gptWindowId, { focused: true }, (res) => {
								if (!res) {
									openpage();
								}
							});
						}
					});
				} else {
					openpage();
				}
			});
		} else {
			openpage();
		}
	}
    
	// 打开CaptainGPT窗口
	function openpage() {
		// 默认宽高和位置
		let newWindowWidth = 1360;
		let newWindowHeight = 700;
		let newWindowLeft = 0;
		let newWindowTop = 0;
		if (currentWindow) {
			newWindowLeft = currentWindow.left + currentWindow.width - newWindowWidth
			// 聚焦一下当前窗口，主要是为了关闭popup
			chrome.windows.update(currentWindow.id, { focused: true })
		}
		chrome.windows && chrome.windows.create({
			url: "../views/CaptainGPT/dist/index.html?type='gptSingleWindow'", // 一个Vue项目打包后的入口文件
			type: "popup",
			width: newWindowWidth,
			height: newWindowHeight,
			left: newWindowLeft,
			top: newWindowTop
		}, (createdWindow) => {
			// 聚焦到新窗口
			chrome.windows.update(createdWindow.id, { focused: true });
			// 将窗口ID保存到chrome.storage中
			chrome.storage.local.set({ gptWindowId: createdWindow.id });
		});
	}
}

chrome.runtime.onInstalled.addListener(function() {
	chrome.webRequest.onHeadersReceived.addListener(function(details) {
		const headers = details.responseHeaders.map(header => {
			if (header.name.toLowerCase() === 'set-cookie') {
				header.value += '; SameSite=None';
			}
			return header;
		});
		return { responseHeaders: headers };
	}, {
		urls: ['<all_urls>']
	}, ['blocking', 'responseHeaders']);
});
